#!/usr/bin/perl -w

#use strict;

my $INPUT_PATH ='<input/';
my $OUTPUT_PATH='>output/';

sub assemble_step {
    my ($level, $file, $key)=@_;
    print (('. 'x$level).$file.':'.$key."\n");
    local $/;
    open FH, $INPUT_PATH.$file or die $file.' : '.$!;
    my $text=<FH>;
    close FH;
    $level++;
    $text=~s{\(##[#\s]*([^#\s]+)[#\s]*##\)}{
        my ($fn, $k)=($1, $key);
        $fn=~s/\?/$key/g;
        $fn=~s/\(([^)]+)\)/($key eq $1)?'yes':'no'/ge;
        ($fn, $k)=($1, $2) if ($fn=~m/^([^:]+):(.+)$/);
        assemble_step($level, $fn, $k);
    }ge;
    return $text;
}

sub assemble {
    my ($output, $input_root, $init_key)=@_;
    my $text=assemble_step(0, $input_root, $init_key);
    open FH, $OUTPUT_PATH.$output or die $output.' : '.$!;
    print FH $text;
    close FH;
}

while (<>) { assemble(split) }
